import { type EncodingName, type ModelName } from './mapping.js';
import { type GetMergeableRanksAsyncFn, type GetMergeableRanksFn } from './modelParams.js';
export declare const DISALLOW_ALL_SPECIAL_TOKENS = "all";
export declare class GptEncoding {
    static EndOfPrompt: string;
    static EndOfText: string;
    static FimMiddle: string;
    static FimPrefix: string;
    static FimSuffix: string;
    decoder: TextDecoder;
    private bytePairEncodingCoreProcessor;
    private specialTokenMapping;
    private constructor();
    static getEncodingApi(encodingName: EncodingName, getMergeableRanks: GetMergeableRanksFn): GptEncoding;
    static getEncodingApiForModel(modelName: ModelName, getMergeableRanks: GetMergeableRanksFn): GptEncoding;
    static getEncodingApiAsync(encodingName: EncodingName, getMergeableRanks: GetMergeableRanksAsyncFn): Promise<GptEncoding>;
    static getEncodingApiForModelAsync(modelName: ModelName, getMergeableRanks: GetMergeableRanksAsyncFn): Promise<GptEncoding>;
    private static getMaxValueFromMap;
    private static specialTokenRegex;
    encodeGenerator(lineToEncode: string, allowedSpecial?: Set<string>, disallowedSpecial?: Set<string>): Generator<number[], number>;
    encode(lineToEncode: string, allowedSpecial?: Set<string>, disallowedSpecial?: Set<string>): number[];
    /**
     * @returns {false | number} false if token limit is exceeded, otherwise the number of tokens
     */
    isWithinTokenLimit(text: string, tokenLimit: number): false | number;
    decodeGenerator(inputTokensToDecode: Iterable<number>): Generator<string, void>;
    decodeAsyncGenerator(inputTokensToDecode: AsyncIterable<number>): AsyncGenerator<string, void>;
    decode(inputTokensToDecode: Iterable<number>): string;
}
